/*
 * A sample parallel application.
 *
 * Now this one is real stupid: there is a vector of zeros, and T threads.
 * Each thread, upon creation, contends for the indexLock, and, having it
 * acquired, reads the Index, increments it, and releases the lock.
 * The read value will be his ID, and it will be the position of the element
 * in the vector that he will be incrementing N times, in parallel with
 * other T-1 threads that will be incrementing their element.
 * 
 * All in all, damn silly and as much useful in debugging.
 */
 
#include <stdio.h>

#if 0
typedef double vectype;
#define INITVAL 0.01
#define PRINTF "%lf "
#define DEF_N_INCS 4
#define INCVAL 1
#else
typedef long vectype;
#define INITVAL 0
#define PRINTF "%d "
#define DEF_N_INCS 4
#define INCVAL 1
#endif

#define MAXPROCS 64
int numProcs=4;             /* 4 processes in parallel */
int N_INCS = DEF_N_INCS;    /* how many times will it be incremented. */

/* truly shared vars */
LOCKDEC(indexLock);
int Index; /* Used by processors to determine which input to take */
BARDEC(slaveBarrier); 
vectype vector[MAXPROCS];

void SlaveStart();

void main(int argc, char*argv[]) {
    int i;
    unsigned time;

    if (argc>1) sscanf(argv[1],"%d", &N_INCS);

    /* Initialize the Index */
    Index = 0;

    /* Initialize the barrier and the locks */
    LOCKINIT(indexLock) 
    BARINIT(slaveBarrier)

    /* Set up the input assignments */
    for(i=0; i< numProcs; ++i) 
        vector[i] = INITVAL;

    CLOCK(time);

    /* Create the slave processes. */
    for (i = 0; i < numProcs-1; i++)
        CREATE(SlaveStart)
        
    /* Make the master do slave work so we don't waste a processor */
    SlaveStart();        

    /* wait for all the slaves to complete */
    WAIT_FOR_END(numProcs-1)

    CLOCK(time);
    printf("Elapsed time (in cycles): %d\n", time); 

    /* Output the result */
    printf("The vector is now [");
    for (i=0; i< numProcs; i++) printf(PRINTF, vector[i]);
    printf("]\n"); 

    }

/* This is the routine that each processor will be executing in parallel */
void SlaveStart() {
    int myIndex, i; 

    LOCK(indexLock);        /* enter the critical section */
    
    for(i=0; i<10; ++i);    /* make the others busy wait a little ;-) */

    myIndex = Index;        /* read your ID */

    ++Index;                /* increment it, so the next will operate on ID+1 */
    UNLOCK(indexLock);      /* leave the critical section */

    /* all the threads increment their elements in parallel */
    for(i=0; i<N_INCS; ++i) {
        vector[myIndex] += INCVAL; 
        }

    /* Stop at the barrier to synchronize then exit */
    BARRIER(slaveBarrier, numProcs) 
    }
