#ifndef _AUGMENT_H_
#define _AUGMENT_H_

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Header: augment.h
 * Author: Davor Magdic, magdic00390d@buef31.etf.bg.ac.yu
 *
 * Declares the structure that contains all the information
 * about the structure currently being processed.
 * Maximum number of instructions: all the i386+ instructions have at most
 * two arguments, but your own instructions may have more. Five should be
 * enough anyway.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#define MAX_INSTR_ARGS 5    

extern int islabel;                 /* boolean */
struct Instruction {
    char line[100];                 /* the full line from the original .s */
    int  linenumber;                /* its number */
    char name[30];                  /* "movl", for example */
    int  argc;                      /* argument count */
    char argv[MAX_INSTR_ARGS][100]; /* argument vector */
    int  memo[MAX_INSTR_ARGS];      /* whether the arg is an address in mem or not */
    int  memory;                    /* whether *any* of the arguments is mem addr */
    } yyinstr;

#endif /* _AUGMENT_H_ */
