#################################
# Definitions of global variables
# included by all.make
#################################

# default memory simulator: ideal
ifndef SIM
SIM                 = ideal
endif
ifndef SIMHOME
SIMHOME             = $(SIM)
endif

# for parallel algorithms evaluation, abstract sync primitives can be used
ifdef ALGEVALONLY
ifndef SYNC
SYNC                = abstract
endif
export ALGEVALONLY_SWITCH = -DALGEVALONLY=1
endif

# default implementation of synchronization primitives: realistic
ifndef SYNC
SYNC                = realistic
endif


# dirs
export KERNELDIR    = $(LIMESDIR)/kernel
export INCLUDEDIR   = $(LIMESDIR)/kernel
export SYNCDIR      = $(LIMESDIR)/sync/$(SYNC)
export SYS_STDLIBDIR= $(LIMESDIR)/sys_stdlib
export LIBDIR       = $(LIMESDIR)/lib
export AUGDIR       = $(LIMESDIR)/aug
export SIMDIR       = $(LIMESDIR)/simulators/$(SIMHOME)
export DTDIR        = $(LIMESDIR)/simulators

# libs
export KERNELLIB    = $(LIBDIR)/kernel.a
export INTERFACELIB = $(LIBDIR)/interface.a
export SYNCLIB      = $(LIBDIR)/sync_$(SYNC).a
export SIMLIB       = $(LIBDIR)/$(SIM).a
export APPLIB       = $(LIBDIR)/$(TARGET).a

#vars
export SIM
export SYNC

##################################################################
# gcc 2.6.3 (a.out) compiler files
# If you are running a Linux system with GCC version greater than
# 2.6.3, you must install the entire 2.6.3 development environment
# into a directory of your choice (/oldgcc in this example).
# (Note: you do not have to reinstall old gdb, make, and flex.)
# And, of course, to put ifeq (1,1) in the line below.
# Please consult the documentation for details and examples.
##################################################################

ifeq (1,1)			# for systems with GCC 2.7.0 (ELF) or higher

# position of GCC,LIB,BINUTILS files. You need only to change this one.
# Make sure you don't have extra blanks after the directory name!
GCC263=/root/oldgcc

# binaries. leave these as they are.
export GCC=$(GCC263)/usr/bin/gcc
export GCPP=$(GCC263)/usr/bin/g++
export AS=$(GCC263)/usr/bin/as
export AR=$(GCC263)/usr/bin/ar

# compiler paths. no need to touch them.
export GCC_EXEC_PREFIX=$(GCC263)/usr/lib/gcc-lib/i486-linux/2.6.3
export COMPILER_PATH=$(GCC263)/usr/lib/gcc-lib/i486-linux/2.6.3:$(GCC263)/usr/bin
export C_INCLUDE_PATH=$(GCC263)/usr/lib/gcc-lib/i486-linux/2.6.3/include:$(GCC263)/usr/include
export CPLUS_INCLUDE_PATH=$(C_INCLUDE_PATH):$(GCC263)/usr/include/g++
export LIBRARY_PATH=$(GCC263)/lib:$(GCC263)/usr/lib

else				# for systems with GCC 2.6.3 (AOUT)

export GCC=gcc
export GCPP=g++
export AS=as
export AR=ar

endif
