#######################################################################
# This makefile is called from the directory where the actual simulator
# resides, and whose name is defined in the SIM variable. The caller
# needs to define only SIM (say, SIM = ber) and TARGET (if he doesn't
# like a.out) and to include this make file. This file will call
# $(SIM).make, which must ensure that the $(SIM).a archive is created,
# whereafter this makefile links the support for detached simulation
# with the object files in the actual simulator's archive.
#######################################################################

export SIMTYPE = DETACHED
export SIMOPT = -D$(SIMTYPE)

include	$(LIMESDIR)/globals.make		# dir definitions

DTCS   = $(DTDIR)/detached.c $(DTDIR)/lex.yy.c
DTOS   = $(DTCS:.c=.o)
CC     = $(GCC) -I$(INCLUDEDIR) $(SIMOPT)
LDCTRL = $(GCPP)

ifndef TARGET
TARGET	= a.out
endif
export TARGET

$(TARGET) : $(DTOS) $(SIMLIB)
	$(LDCTRL) $(DTOS) $(SIMLIB) -o $(TARGET)

$(SIMLIB) : FORCE
	make -f $(SIM).make
FORCE:

$(DTOS): %.o : %.c
	$(CC) -c $< -o $@

$(DTDIR)/lex.yy.c: $(DTDIR)/trace.lex
	flex -i -o$(DTDIR)/lex.yy.c $(DTDIR)/trace.lex 

############### dep and clean ##############
dep:
	$(CC) -MM $(DTCS) > $(DTDIR)/.depend	# deps for "detached" support
	make -f $(SIM).make dep			# deps for the simulator

ifeq ($(DTDIR)/.depend, $(wildcard $(DTDIR)/.depend))
include $(DTDIR)/.depend
endif

clean:
	rm -rf $(DTOS) $(DTDIR)/lex.yy.c	# delete .o's and lex.yy.c
	make -f $(SIM).make clean		# make the memsim clean
