#ifndef _MESI_LINE_STATE_H_
#define _MESI_LINE_STATE_H_

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Module: mesi_line_state.h
 * Author: Aleksandar Milenkovic, emilenka@ubbg.etf.bg.ac.yu
 * Date: March, 1997
 * Line states for the MESI (Modified, Exclusive, Shared, Invalid) protocol
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

class MESI_Line_State {
  public:
    enum State { INVALID, SHARED, EXCLUSIVE, MODIFIED } state;
    MESI_Line_State()                {state = INVALID;}
    bool  isvalid()		     {state != INVALID;}
    State get()                      {return state;}
    void  set(State new_state)       {state = new_state; }
    char  symbol()                   {
    				      switch (state) {
    				        case INVALID:   return 'I';
    				        case SHARED:    return 'S';
    				        case EXCLUSIVE: return 'E';
    				        case MODIFIED:  return 'M';
    				       }
    				     }
    };

#endif //_MESI_LINE_STATE_H_
