#ifndef _SYS_STDLIB_H_
#define _SYS_STDLIB_H_

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Header: macros.h
 * Author: Davor Magdic, magdic00390d@buef31.etf.bg.ac.yu
 *
 * Defines aliases -- redirections for certain standard library functions.
 * Only the application includes this file.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "sys_stdlib.h"

#define scanf(args...)  sys_scanf(args)
#define fscanf(args...) sys_fscanf(args)
#define sscanf(args...) sys_sscanf(args)

#define sprintf(args...) sys_sprintf(args)

#define strlen(S)       sys_strlen(S)
#define strcpy(D,S)     sys_strcpy(D,S)
#define strncpy(D,S,N)  sys_strncpy(D,S,N)
#define strcat(D,S)     sys_strcat(D,S)
#define strncat(D,S,N)  sys_strncat(D,S,N)
#define strchr(S,C)     sys_strchr(S,C)
#define strcmp(S1,S2)   sys_strcmp(S1,S2)
#define strncmp(S1,S2,N) strncmp(S1,S2,N)
#define memcpy(D,S,N)   sys_memcpy(D,S,N)

#define atoi(S)         sys_atoi(S)
#define atol(S)         sys_atol(S)
#define strtol(S,E,B)   sys_strtol(S,E,B)
#define atof(S)         ({double d;sys_sscanf(S, "%lf", &d);d;})

#endif _SYS_STDLIB_H_
