#ifndef _SYS_STDLIB_H_
#define _SYS_STDLIB_H_

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Header: sys_stdlib.h
 * Author: Davor Magdic, magdic00390d@buef31.etf.bg.ac.yu
 *
 * This header file defines prototypes for standard library functions
 * replacements
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* scanf and brothers */
int sys_scanf( char *format, ...);
int sys_fscanf( FILE *stream, char *format, ...);
int sys_sscanf( char *str, char *format, ...);

/* printf */
int sys_sprintf( char *str, const char *format, ...);

/* string functions */
size_t sys_strlen(const char *s);
char * sys_strcpy(char *dest, const char *src);
char * sys_strncpy(char *dest, const char *src, size_t n);
char * sys_strcat(char *dest, const char *src);
char * sys_strncat(char *dest, const char *src, size_t n);
char * sys_strchr(const char *s, int c);
int sys_strcmp(const char *s1, const char *s2);
int sys_strncmp(const char *s1, const char *s2, size_t n);
void * sys_memcpy(void *dest, const void *src, size_t n);

/* atoi functions */
int  sys_atoi(const char *nptr);
long sys_atol(const char *nptr);
long sys_strtol(const char *nptr, char **endptr, int base);

#endif /* _SYS_STDLIB_H_ */