/*
 * This file contains data structures used within tracer.c and trace.lex files
 */


/*
 *
 *  Hash tables
 *
 */

#define HASHTABLE_SIZE 30

struct list_element_1 {
    bitsADDR   address;
    bitsLOCK   value;
    struct list_element_1 *next;
};

struct hash_table_entry {
    struct list_element_1 *list_head;
};

typedef struct hash_table_entry type_hash_table;


/*
 *
 *  Tables of lists
 *
 */

struct list_element_2 {
    /* ENTER */
    bitsADDR    address;
    int         total;
    Thread_Time ENTER_time;
    long int    ENTER_pos;
    /* IN */
    int         IN_order;
    Thread_Time IN_time;
    Thread_Time original_IN_time;
    /* WAIT */
    Thread_Time WAIT_time;
    long int    WAIT_pos;
    /* OUT */
    int         OUT_order;
    Thread_Time OUT_time;
    Thread_Time original_OUT_time;
    /* EXIT */
    Thread_Time EXIT_time;
    long int    EXIT_pos;
    struct list_element_2 *next;
};

struct table_of_lists_entry {
    struct list_element_2 *list_head;
    struct list_element_2 *list_tail;
};

typedef struct table_of_lists_entry type_table_of_lists;
